GNU bug report logs - #12986
Pressing backspace during isearch exits case-sensitive and word modes

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: Kelly Dean <kellydeanch@HIDDEN>; Keywords: patch; dated Sun, 25 Nov 2012 01:58:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 12986 <at> debbugs.gnu.org:


Received: (at 12986) by debbugs.gnu.org; 10 May 2021 11:20:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 10 07:20:51 2021
Received: from localhost ([127.0.0.1]:57511 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lg3xz-0006Ci-Ed
	for submit <at> debbugs.gnu.org; Mon, 10 May 2021 07:20:51 -0400
Received: from quimby.gnus.org ([95.216.78.240]:34040)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lg3xx-0006CV-Uj
 for 12986 <at> debbugs.gnu.org; Mon, 10 May 2021 07:20:50 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=HbgApiDrflvxQ8AR8K39gZuwj/sHGHsZPUi5o8OVDBw=; b=dNbNTDNOPjgwHynhvxGNK+vu9R
 ieuJCgMTASiFuxQ0uh5bDI44+L3Cv7TIkf81mYr2ioP0LGy7rz92M+JltuGZrlauLvso8dA3ehX6L
 vysaz99xR5/ic7Z8lSEct08FNLVZ7DyKVMn3DrctoD3GvaqjeXpKI73VaOquK8m0t63o=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lg3xp-0007QE-Rp; Mon, 10 May 2021 13:20:44 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#12986: Pressing backspace during isearch exits
 case-sensitive and word modes
References: <1354124058.21763.YahooMailClassic@HIDDEN>
 <87a9u1jqzh.fsf@HIDDEN> <87obbolu5c.fsf@HIDDEN>
 <877dru97yv.fsf@HIDDEN>
X-Now-Playing: Severed Heads's _Gigapus_: "Arrivederci Coma"
Date: Mon, 10 May 2021 13:20:41 +0200
In-Reply-To: <877dru97yv.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Tue,
 13 Oct 2020 04:26:48 +0200")
Message-ID: <875yzqu96e.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Lars Ingebrigtsen <larsi@HIDDEN> writes: > I respun the
 patch for Emacs 28, but looking at it, I guess it doesn't > support actually
 restoring the modes it's discussing? But I guess since the companion patch
 in bug#11378 was never applied, it's a moot issue. Juri, is this something
 that should still be worked on, or has this patch (and the one in bug#11378)
 been aband [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 12986
Cc: 12986 <at> debbugs.gnu.org, Kelly Dean <kellydeanch@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> I respun the patch for Emacs 28, but looking at it, I guess it doesn't
> support actually restoring the modes it's discussing?

But I guess since the companion patch in bug#11378 was never applied,
it's a moot issue.  Juri, is this something that should still be worked
on, or has this patch (and the one in bug#11378) been abandoned?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12986; Package emacs. Full text available.

Message received at 12986 <at> debbugs.gnu.org:


Received: (at 12986) by debbugs.gnu.org; 13 Oct 2020 02:27:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 12 22:27:09 2020
Received: from localhost ([127.0.0.1]:44612 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kSA1t-0007mX-0R
	for submit <at> debbugs.gnu.org; Mon, 12 Oct 2020 22:27:09 -0400
Received: from quimby.gnus.org ([95.216.78.240]:40748)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kSA1q-0007ly-3f
 for 12986 <at> debbugs.gnu.org; Mon, 12 Oct 2020 22:27:08 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=2wBbG8rGgLB4ekkNUt3V/XaCqdYeG0exHFi8q2/K3m4=; b=nqvLo2Jt2Ed1P4KCKfBt6PDC5o
 VH5hkHZGC7M8SKTsbf6CHLwQDjdkflPOUvSrmgroHRuayQ7zMjAgbsfhoIDri+pDtVYYUrmq2tiTc
 RSeEXQJ3whkR5SWV8WmK4fyrZe/SieraGPaDstZmtuFCXeK4D8/iSQneYHyIwCM1lcAU=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kSA1Z-00010I-Op; Tue, 13 Oct 2020 04:26:59 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#12986: Pressing backspace during isearch exits
 case-sensitive and word modes
References: <1354124058.21763.YahooMailClassic@HIDDEN>
 <87a9u1jqzh.fsf@HIDDEN> <87obbolu5c.fsf@HIDDEN>
X-Now-Playing: Oval's _Wohnton_: "WoistdieStadt?"
Date: Tue, 13 Oct 2020 04:26:48 +0200
In-Reply-To: <87obbolu5c.fsf@HIDDEN> (Juri Linkov's message of "Sun,
 02 Jun 2013 12:49:19 +0300")
Message-ID: <877dru97yv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Juri Linkov <juri@HIDDEN> writes: >> Good point.
 `isearch-delete-char'
 (that uses `isearch-pop-state') >> restores word mode but not regexp mode.
 This looks like >> unaccountable inconsistency. Perhaps it should restore
 >> regexp mode [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 12986
Cc: 12986 <at> debbugs.gnu.org, Kelly Dean <kellydeanch@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Juri Linkov <juri@HIDDEN> writes:

>> Good point.  `isearch-delete-char' (that uses `isearch-pop-state')
>> restores word mode but not regexp mode.  This looks like
>> unaccountable inconsistency.  Perhaps it should restore
>> regexp mode as well.

[...]

> This patch adds a new user option `isearch-keep-stack-variables'
> intended to accompany another option `isearch-keep-mode-variables'
> added in bug#11378.  It adds a new option but doesn't change
> the default behavior - its default value is `isearch-regexp'
> that means to not keep regexp mode when pressing backspace
> (other search variables will be supported later as well).

I respun the patch for Emacs 28, but looking at it, I guess it doesn't
support actually restoring the modes it's discussing?

diff --git a/lisp/isearch.el b/lisp/isearch.el
index 0879f948cf..e9a3a2e921 100644
--- a/lisp/isearch.el
+++ b/lisp/isearch.el
@@ -167,6 +167,17 @@ isearch-hide-immediately
 the search, with the exception of the last successful match, if any."
   :type 'boolean)
 
+(defcustom isearch-keep-stack-variables '(isearch-regexp)
+  "A set of search variables to keep and not to restore from the search stack."
+  :type '(set (const :tag "Regexp search" isearch-regexp)
+	      (const :tag "Case folding" isearch-case-fold-search)
+	      (const :tag "Invisible text" isearch-invisible)
+	      (const :tag "Filters" isearch-filter-predicates)
+	      (const :tag "Lax whitespace" isearch-lax-whitespace)
+	      (const :tag "Regexp lax whitespace" isearch-regexp-lax-whitespace))
+  :version "28.1"
+  :group 'isearch)
+
 (defcustom isearch-resume-in-command-history nil
   "If non-nil, `isearch-resume' commands are added to the command history.
 This allows you to resume earlier Isearch sessions through the
@@ -1515,6 +1526,7 @@ isearch-update-from-string-properties
                  (case-fold-search isearch-case-fold-search)
                  (pop-fun (if isearch-push-state-function
                               (funcall isearch-push-state-function)))
+		 (regexp isearch-regexp)
                  (match-data isearch-match-data))))
   (string nil :read-only t)
   (message nil :read-only t)
@@ -1528,6 +1540,7 @@ isearch-update-from-string-properties
   (barrier nil :read-only t)
   (case-fold-search nil :read-only t)
   (pop-fun nil :read-only t)
+  (regexp :read-only t)
   (match-data nil :read-only t))
 
 (defun isearch--set-state (cmd)
@@ -1542,6 +1555,8 @@ isearch--set-state
 	isearch-barrier (isearch--state-barrier cmd)
 	isearch-case-fold-search (isearch--state-case-fold-search cmd)
 	isearch-match-data (isearch--state-match-data cmd))
+  (unless (memq 'isearch-regexp isearch-keep-stack-variables)
+    (setq isearch-regexp (isearch--state-regexp cmd)))
   (if (functionp (isearch--state-pop-fun cmd))
       (funcall (isearch--state-pop-fun cmd) cmd))
   (goto-char (isearch--state-point cmd)))

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12986; Package emacs. Full text available.
Added tag(s) patch. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 12986 <at> debbugs.gnu.org:


Received: (at 12986) by debbugs.gnu.org; 2 Jun 2013 09:55:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 02 05:55:52 2013
Received: from localhost ([127.0.0.1]:47346 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Uj50x-0002AQ-Jz
	for submit <at> debbugs.gnu.org; Sun, 02 Jun 2013 05:55:51 -0400
Received: from ps18281.dreamhost.com ([69.163.218.105]:36922
	helo=ps18281.dreamhostps.com)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <juri@HIDDEN>) id 1Uj50u-00029t-3h
	for 12986 <at> debbugs.gnu.org; Sun, 02 Jun 2013 05:55:49 -0400
Received: from localhost (ps18281.dreamhostps.com [69.163.218.105])
	by ps18281.dreamhostps.com (Postfix) with ESMTP id 31378258B9E938;
	Sun,  2 Jun 2013 02:54:01 -0700 (PDT)
From: Juri Linkov <juri@HIDDEN>
To: Kelly Dean <kellydeanch@HIDDEN>
Subject: Re: bug#12986: Pressing backspace during isearch exits case-sensitive
	and word modes
Organization: JURTA
References: <1354124058.21763.YahooMailClassic@HIDDEN>
	<87a9u1jqzh.fsf@HIDDEN>
Date: Sun, 02 Jun 2013 12:49:19 +0300
In-Reply-To: <87a9u1jqzh.fsf@HIDDEN> (Juri Linkov's message of "Thu,
	29 Nov 2012 01:15:14 +0200")
Message-ID: <87obbolu5c.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 12986
Cc: 12986 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

>> But it still seems to be a UI inconsistency: although the described
>> behavior happens for word mode and case-insensitivity mode, it
>> doesn't happen for regex mode, which it what led me to believe it was
>> a bug for the first two. If it's supposed to happen for the first two,
>> then shouldn't it happen for all three?
>
> Good point.  `isearch-delete-char' (that uses `isearch-pop-state')
> restores word mode but not regexp mode.  This looks like
> unaccountable inconsistency.  Perhaps it should restore
> regexp mode as well.
>
> Case-insensitivity is already restored when you type <backspace>
> but you can't see this because it has no indication in the prompt.
> Maybe it should momentarily flash a case sensitivity indicator
> when you type <backspace> like it does when you type `M-c'
> (but only when <backspace> changes the state of case-insensitivity).
>
> The recently added `isearch-lax-whitespace' could be saved/restored too.
>
> For customizability a new user option could be added to define a list
> of search states that the user wants to keep on the isearch stack.

This patch adds a new user option `isearch-keep-stack-variables'
intended to accompany another option `isearch-keep-mode-variables'
added in bug#11378.  It adds a new option but doesn't change
the default behavior - its default value is `isearch-regexp'
that means to not keep regexp mode when pressing backspace
(other search variables will be supported later as well).

=== modified file 'lisp/isearch.el'
--- lisp/isearch.el	2013-05-30 23:50:36 +0000
+++ lisp/isearch.el	2013-06-02 09:45:01 +0000
@@ -153,6 +153,17 @@ (defcustom isearch-hide-immediately t
   :type 'boolean
   :group 'isearch)
 
+(defcustom isearch-keep-stack-variables '(isearch-regexp)
+  "A set of search variables to keep and not to restore from the search stack."
+  :type '(set (const :tag "Regexp search" isearch-regexp)
+	      (const :tag "Case folding" isearch-case-fold-search)
+	      (const :tag "Invisible text" isearch-invisible)
+	      (const :tag "Filters" isearch-filter-predicates)
+	      (const :tag "Lax whitespace" isearch-lax-whitespace)
+	      (const :tag "Regexp lax whitespace" isearch-regexp-lax-whitespace))
+  :version "24.4"
+  :group 'isearch)
+
 (defcustom isearch-resume-in-command-history nil
   "If non-nil, `isearch-resume' commands are added to the command history.
 This allows you to resume earlier Isearch sessions through the
@@ -1109,6 +1143,7 @@ (cl-defstruct (isearch--state
                  (case-fold-search isearch-case-fold-search)
                  (pop-fun (if isearch-push-state-function
                               (funcall isearch-push-state-function)))
+		 (regexp isearch-regexp)
 		 (filter-predicates isearch-filter-predicates))))
   (string :read-only t)
   (message :read-only t)
@@ -1122,6 +1157,7 @@ (cl-defstruct (isearch--state
   (barrier :read-only t)
   (case-fold-search :read-only t)
   (pop-fun :read-only t)
+  (regexp :read-only t)
   (filter-predicates :read-only t))
 
 (defun isearch--set-state (cmd)
@@ -1136,6 +1172,8 @@ (defun isearch--set-state (cmd)
 	isearch-barrier (isearch--state-barrier cmd)
 	isearch-case-fold-search (isearch--state-case-fold-search cmd)
 	isearch-filter-predicates (isearch--state-filter-predicates cmd))
+  (unless (memq 'isearch-regexp isearch-keep-stack-variables)
+    (setq isearch-regexp (isearch--state-regexp cmd)))
   (if (functionp (isearch--state-pop-fun cmd))
       (funcall (isearch--state-pop-fun cmd) cmd))
   (goto-char (isearch--state-point cmd)))





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12986; Package emacs. Full text available.

Message received at 12986 <at> debbugs.gnu.org:


Received: (at 12986) by debbugs.gnu.org; 28 Nov 2012 23:32:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 28 18:32:29 2012
Received: from localhost ([127.0.0.1]:44247 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Tdr7F-00043v-HG
	for submit <at> debbugs.gnu.org; Wed, 28 Nov 2012 18:32:29 -0500
Received: from ps18281.dreamhost.com ([69.163.218.105]:36143
	helo=ps18281.dreamhostps.com)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <juri@HIDDEN>) id 1Tdr7C-00043f-GQ
	for 12986 <at> debbugs.gnu.org; Wed, 28 Nov 2012 18:32:27 -0500
Received: from localhost (ps18281.dreamhostps.com [69.163.218.105])
	by ps18281.dreamhostps.com (Postfix) with ESMTP id E92C0451C587;
	Wed, 28 Nov 2012 15:30:27 -0800 (PST)
From: Juri Linkov <juri@HIDDEN>
To: Kelly Dean <kellydeanch@HIDDEN>
Subject: Re: bug#12986: Pressing backspace during isearch exits case-sensitive
	and word modes
Organization: JURTA
References: <1354124058.21763.YahooMailClassic@HIDDEN>
Date: Thu, 29 Nov 2012 01:15:14 +0200
In-Reply-To: <1354124058.21763.YahooMailClassic@HIDDEN>
	(Kelly Dean's message of "Wed, 28 Nov 2012 09:34:18 -0800 (PST)")
Message-ID: <87a9u1jqzh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 12986
Cc: 12986 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

[please keep your replies Cc'd to 12986 <at> debbugs.gnu.org]

>> <backspace> (isearch-delete-char) restores the previous search state.
>> If you want just to remove the last character from the search string,
>> you can type `C-M-w' (isearch-del-char).

> Sorry for the mistaken bug report. But it still seems to be a UI
> inconsistency: although the described behavior happens for word mode and
> case-insensitivity mode, it doesn't happen for regex mode, which it what
> led me to believe it was a bug for the first two. If it's supposed to
> happen for the first two, then shouldn't it happen for all three?

Good point.  `isearch-delete-char' (that uses `isearch-pop-state')
restores word mode but not regexp mode.  This looks like
unaccountable inconsistency.  Perhaps it should restore
regexp mode as well.

Case-insensitivity is already restored when you type <backspace>
but you can't see this because it has no indication in the prompt.
Maybe it should momentarily flash a case sensitivity indicator
when you type <backspace> like it does when you type `M-c'
(but only when <backspace> changes the state of case-insensitivity).

The recently added `isearch-lax-whitespace' could be saved/restored too.

For customizability a new user option could be added to define a list
of search states that the user wants to keep on the isearch stack.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12986; Package emacs. Full text available.

Message received at 12986 <at> debbugs.gnu.org:


Received: (at 12986) by debbugs.gnu.org; 25 Nov 2012 09:54:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 25 04:54:28 2012
Received: from localhost ([127.0.0.1]:37488 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TcYux-0001Pm-TB
	for submit <at> debbugs.gnu.org; Sun, 25 Nov 2012 04:54:28 -0500
Received: from ps18281.dreamhost.com ([69.163.218.105]:45969
	helo=ps18281.dreamhostps.com)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <juri@HIDDEN>) id 1TcYuv-0001Pc-GK
	for 12986 <at> debbugs.gnu.org; Sun, 25 Nov 2012 04:54:25 -0500
Received: from localhost (ps18281.dreamhostps.com [69.163.218.105])
	by ps18281.dreamhostps.com (Postfix) with ESMTP id 04656451E18A;
	Sun, 25 Nov 2012 01:52:47 -0800 (PST)
From: Juri Linkov <juri@HIDDEN>
To: Kelly Dean <kellydeanch@HIDDEN>
Subject: Re: bug#12986: Pressing backspace during isearch exits case-sensitive
	and word modes
Organization: JURTA
References: <1353808522.99119.YahooMailClassic@HIDDEN>
Date: Sun, 25 Nov 2012 11:32:03 +0200
In-Reply-To: <1353808522.99119.YahooMailClassic@HIDDEN>
	(Kelly Dean's message of "Sat, 24 Nov 2012 17:55:22 -0800 (PST)")
Message-ID: <87lidq9gfg.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 12986
Cc: 12986 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

> Using 24.2, type:
> onto to
> Then do:
> C-a C-s to
> It highlights the first occurrence of "to" as the current match,
> and the second as the next match.
> Then do: M-s w
> Now, if you type a space, it continues in word mode as expected, but
> if instead you backspace over the o, it exits word mode. It shouldn't do that.
> This same problem applies to case-sensitivity mode (M-c) too.

<backspace> (isearch-delete-char) restores the previous search state.
If you want just to remove the last character from the search string,
you can type `C-M-w' (isearch-del-char).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12986; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 Nov 2012 01:57:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 24 20:57:12 2012
Received: from localhost ([127.0.0.1]:37172 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TcRT2-0005Uy-2G
	for submit <at> debbugs.gnu.org; Sat, 24 Nov 2012 20:57:09 -0500
Received: from eggs.gnu.org ([208.118.235.92]:40446)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <kellydeanch@HIDDEN>) id 1TcRSy-0005Uq-Qx
	for submit <at> debbugs.gnu.org; Sat, 24 Nov 2012 20:57:05 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <kellydeanch@HIDDEN>) id 1TcRRN-0002cW-Ni
	for submit <at> debbugs.gnu.org; Sat, 24 Nov 2012 20:55:30 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-6.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_HI,T_DKIM_INVALID autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:35281)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <kellydeanch@HIDDEN>) id 1TcRRN-0002cS-KW
	for submit <at> debbugs.gnu.org; Sat, 24 Nov 2012 20:55:25 -0500
Received: from eggs.gnu.org ([208.118.235.92]:46109)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <kellydeanch@HIDDEN>) id 1TcRRM-0006Dl-Ml
	for bug-gnu-emacs@HIDDEN; Sat, 24 Nov 2012 20:55:25 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <kellydeanch@HIDDEN>) id 1TcRRL-0002cH-Mm
	for bug-gnu-emacs@HIDDEN; Sat, 24 Nov 2012 20:55:24 -0500
Received: from nm20-vm0.bullet.mail.bf1.yahoo.com ([98.139.213.165]:42898)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <kellydeanch@HIDDEN>) id 1TcRRL-0002cB-GV
	for bug-gnu-emacs@HIDDEN; Sat, 24 Nov 2012 20:55:23 -0500
Received: from [98.139.214.32] by nm20.bullet.mail.bf1.yahoo.com with NNFMP;
	25 Nov 2012 01:55:23 -0000
Received: from [98.139.212.242] by tm15.bullet.mail.bf1.yahoo.com with NNFMP;
	25 Nov 2012 01:55:23 -0000
Received: from [127.0.0.1] by omp1051.mail.bf1.yahoo.com with NNFMP;
	25 Nov 2012 01:55:23 -0000
X-Yahoo-Newman-Property: ymail-3
X-Yahoo-Newman-Id: 33507.60955.bm@HIDDEN
Received: (qmail 45406 invoked by uid 60001); 25 Nov 2012 01:55:23 -0000
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=yahoo.com; s=s1024;
	t=1353808522; bh=j8wYHSK5BkeB8Lad8x90NRNYf/2ddb7coBt76JNTc18=;
	h=X-YMail-OSG:Received:X-Rocket-MIMEInfo:X-Mailer:Message-ID:Date:From:Subject:To:MIME-Version:Content-Type;
	b=1zE16kgeAp7Dc5VHpez9tMk9xoV1Yetmm0Hvxg220hjy5zf+stbxVEH9DZDr92mUPGzmIT+H+g/o3UaCsCyqWhasphm6HFrn2TmUWVVxS2QoSyvEo9es0cfdFhLJepdRhY2rFn0AyQS5gHjnGQko7BWB0/J5GN8Wyki6ZXTIjRY=
DomainKey-Signature: a=rsa-sha1; q=dns; c=nofws; s=s1024; d=yahoo.com;
	h=X-YMail-OSG:Received:X-Rocket-MIMEInfo:X-Mailer:Message-ID:Date:From:Subject:To:MIME-Version:Content-Type;
	b=r35BdlYqAUpxWdg2XgmyBITkKwnjwSVghL9ipWJZQhtd8V5/pqkWnQEcGPCYNkq9CbmxCKsO4e9Cs1AZtZpEtRbSUqsDIJH/Ty971V9BPT9gQV5KGtXx0DyLHBW/QLT50R2Oci1CvPBcQM/GB/l1wQacSfOf1007Ll06p5QpGL0=;
X-YMail-OSG: 5vXWQUoVM1mfLSFpKxbpix.r1Q_4VI7bAgOU30njkcb5hUP
	PWJbdAS8MElnzT0qrq.pv32KTrfSqwOJTWNi9IUf4kznj9IuNC0t4bHMsXP_
	9zrAueACDHH2dKBwnkr9NRTCzenLzu_ne_JzQu6xnNhJQxiUEZ9pFmkDtCOi
	erCbsK93za.8ArRJvYM19eip5CKQQ_wRkQuH2V0YTvWgty5oEphuDdk1VJmW
	xObMAGL85ttTlU4lbtL8WB03L7d240FcUkyLZs70fa3Y7kk3WbxnboQJW1zG
	V5oaUV7Rw3V1tRzshWeqoAeKRQqDUEcJLML4oecfnt5z.fB_FQb0HJzBck8T
	qjdIABIhMF49d7Sa3MotK5PWijNbwlrpuyk6SWOc5yt1t5Kz43cesApWxTA0
	PxHg4gEYe28SrJFXmpIl5sYlF1KUd4bVbMfrr3jAMSuo-
Received: from [37.130.227.133] by web141103.mail.bf1.yahoo.com via HTTP;
	Sat, 24 Nov 2012 17:55:22 PST
X-Rocket-MIMEInfo: 001.001,
	VXNpbmcgMjQuMiwgdHlwZToKb250byB0bwpUaGVuIGRvOgpDLWEgQy1zIHRvCkl0IGhpZ2hsaWdodHMgdGhlIGZpcnN0IG9jY3VycmVuY2Ugb2YgInRvIiBhcyB0aGUgY3VycmVudCBtYXRjaCwgYW5kIHRoZSBzZWNvbmQgYXMgdGhlIG5leHQgbWF0Y2guClRoZW4gZG86IE0tcyB3Ck5vdywgaWYgeW91IHR5cGUgYSBzcGFjZSwgaXQgY29udGludWVzIGluIHdvcmQgbW9kZSBhcyBleHBlY3RlZCwgYnV0IGlmIGluc3RlYWQgeW91IGJhY2tzcGFjZSBvdmVyIHRoZSBvLCBpdCBleGl0cyB3b3JkIG1vZGUuIEl0IHMBMAEBAQE-
X-Mailer: YahooMailClassic/15.0.8 YahooMailWebService/0.8.123.460
Message-ID: <1353808522.99119.YahooMailClassic@HIDDEN>
Date: Sat, 24 Nov 2012 17:55:22 -0800 (PST)
From: Kelly Dean <kellydeanch@HIDDEN>
Subject: Pressing backspace during isearch exits case-sensitive and word modes
To: bug-gnu-emacs@HIDDEN
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-detected-operating-system: by eggs.gnu.org: FreeBSD 8.x
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

Using 24.2, type:
onto to
Then do:
C-a C-s to
It highlights the first occurrence of "to" as the current match, and the second as the next match.
Then do: M-s w
Now, if you type a space, it continues in word mode as expected, but if instead you backspace over the o, it exits word mode. It shouldn't do that.
This same problem applies to case-sensitivity mode (M-c) too.





Acknowledgement sent to Kelly Dean <kellydeanch@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#12986; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 10 May 2021 11:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.